#include <avr/io.h>
#include <util/delay.h>

main()
{
   
    DDRB = 0b00010101; //ไฟเขียว ไฟเหลือง ไฟแดง เป็น output
    PORTB = 0b00101011; //สวิตซ์ (1,2,3) ทำงาน, ไฟเขียวติด
    DDRC = 0b00101010; //ไฟประตู ไฟปุ่ม buzzer เป็น output
    PORTC = 0b00011101; //สวิตซ์ (reset,รหัส,ประตู) ทำงาน, ไฟปุ่มติด
	
	uint8_t door = 0, pwd1 = 1, pwd2 = 2, pwd3 = 3, //door = ประตูเปิด/ปิด, pwd1 = รหัสที่ถูกตัวแรก, pwd2 = ตัว2, pwd3 = ตัว3
			chk = 0, chkpwd1 = 0, chkpwd2 =  0, chkpwd3 = 0, //chk = รหัสถูก/ผิด, chkpwd1 = กดครั้งแรก, chkpwd2 = ครั้ง2, chkpwd3 = ครั้ง3
			repwd1 = 0, repwd2 = 0, repwd3 = 0; //repwd1 = กดซ้ำครั้งแรก, repwd2 = ครั้ง2, repwd3 = ครั้ง3
	int time1 = 1000, time2 = 2500, time3 = 1000, time4 = 1000;//time = นับถอยหลัง


    while (1)
    {

//====================================================================================================================================================//

		if (((PINC & 0b00010000) == 0) && (door == 0)) //กดเปิดประตู
		{
			PORTC &= 0b11110111; //ไฟปุ่มดับ
			while ((PINC & 0b00010000) == 0) //รอจนกว่าปล่อยปุ่ม
			;
			_delay_ms(2000);
			PORTC |= 0b00001010; //ไฟปุ่ม,ประตู ติด
			PORTB |= 0b00000100; //ไฟเหลืองติด
			PORTB &= 0b11111110; //ไฟเขียวดับ
			door = 1;

//====================================================================================================================================================//
			while (chk == 0) //หลุด loop เมื่อถูกหรือผิด
			{
				time1 -= 1; //นับถอยหลัง
				if (time1 <= 0) {time2 -= 1; time1 = 1000;}

				if (time2 <= 0) chk = 2; //เวลาหมด

				if (chkpwd1 == pwd1 && chkpwd2 == pwd2 && chkpwd3 == pwd3) chk = 1; //รหัส 3 ครั้งถูก
				else if (chkpwd3 != 0) chk = 2; //รหัสผิด

				if (((PINC & 0b00010000) == 0) && (door == 0)) //กดเปิดประตู
				{
					PORTC &= 0b11110111; //ไฟปุ่มดับ
					while ((PINC & 0b00010000) == 0) //รอจนกว่าปล่อยปุ่ม
					{
						time3 -= 1;
						if (time3 <= 0) { time4 -= 1; time3 = 1000; }
						if (time4 <= 0) PORTC |= 0b00100000;
					}
					PORTC &= 0b11011111; // ดับ buzzer
					time3 = 1000; time4 = 1000;
					_delay_ms(2000);
					PORTC |= 0b00001010; //ไฟปุ่ม,ประตู ติด
					door = 1;
				}

				if (((PINC & 0b00010000) == 0) && (door == 1)) //กดปิดประตู
				{
					PORTC &= 0b11110111; //ไฟปุ่มดับ
					while ((PINC & 0b00010000) == 0) //รอจนกว่าปล่อยปุ่ม
					{
						time3 -= 1;
						if (time3 <= 0) { time4 -= 1; time3 = 1000; }
						if (time4 <= 0) PORTC |= 0b00100000;
					}
					PORTC &= 0b11011111; // ดับ buzzer
					time3 = 1000; time4 = 1000;
					_delay_ms(2000);
					PORTC |= 0b00001000; //ไฟปุ่มติด
					PORTC &= 0b11111101; //ไฟประตูดับ
					door = 0;	
				}

				if (((PINB & 0b00000010) == 0)) //กดปุ่มแรก
				{
					PORTC &= 0b11110111; //ไฟปุ่มดับ
					while ((PINB & 0b00000010) == 0) //รอปล่อย ไม่ปล่อย buzzer ร้อง
					{
						time3 -= 1;
						if (time3 <= 0) { time4 -= 1; time3 = 1000; }
						if (time4 <= 0) PORTC |= 0b00100000;
					}
					PORTC &= 0b11011111; // ดับ buzzer
					time3 = 1000; time4 = 1000;
					_delay_ms(2000);
					PORTC |= 0b00001000; //ไฟปุ่มติด
					if (chkpwd1 == 0) chkpwd1 = 1; //ถ้ายังไม่กดครั้งแรก ให้ใส่ค่าแรกก่อน
					else if (chkpwd2 == 0) chkpwd2 = 1; //ครั้ง2
					else if (chkpwd3 == 0) chkpwd3 = 1; //ครั้ง3
				} 

				if (((PINB & 0b00001000) == 0))
				{
					PORTC &= 0b11110111; //ไฟปุ่มดับ
					while ((PINB & 0b00001000) == 0)
					{
						time3 -= 1;
						if (time3 <= 0) { time4 -= 1; time3 = 1000; }
						if (time4 <= 0) PORTC |= 0b00100000;
					}
					PORTC &= 0b11011111; // ดับ buzzer
					time3 = 1000; time4 = 1000;
					_delay_ms(2000);
					PORTC |= 0b00001000; //ไฟปุ่มติด
					if (chkpwd1 == 0) chkpwd1 = 2;
					else if (chkpwd2 == 0) chkpwd2 = 2;
					else if (chkpwd3 == 0) chkpwd3 = 2;
				}

				if (((PINB & 0b00100000) == 0))
				{
					PORTC &= 0b11110111; //ไฟปุ่มดับ
					while ((PINB & 0b00100000) == 0)
					{
						time3 -= 1;
						if (time3 <= 0) { time4 -= 1; time3 = 1000; }
						if (time4 <= 0) PORTC |= 0b00100000;
					}
					PORTC &= 0b11011111; // ดับ buzzer
					time3 = 1000; time4 = 1000;
					_delay_ms(2000);
					PORTC |= 0b00001000; //ไฟปุ่มติด
					if (chkpwd1 == 0) chkpwd1 = 3;
					else if (chkpwd2 == 0) chkpwd2 = 3;
					else if (chkpwd3 == 0) chkpwd3 = 3;
				}

				if (((PINC & 0b00000001) == 0)) //กด reset
				{
					PORTC &= 0b11110111; //ไฟปุ่มดับ
					PORTB |= 0b00000001; //ไฟเขียวติด
					while ((PINC & 0b00000001) == 0)
					{
						time3 -= 1;
						if (time3 <= 0) { time4 -= 1; time3 = 1000; }
						if (time4 <= 0) PORTC |= 0b00100000;
					}
					PORTC &= 0b11011111; // ดับ buzzer
					time3 = 1000; time4 = 1000;
					_delay_ms(2000);
					PORTB &= 0b11111110; //ไฟเขียวดับ
					PORTC |= 0b00001000; //ไฟปุ่มติด
					chkpwd1 = 0; chkpwd2 = 0; chkpwd3 = 0;
				}
			}
//====================================================================================================================================================//
			if (chk == 1)
			{
				PORTB &= 0b11111011;
				PORTB |= 0b00000001;
			}
//====================================================================================================================================================//
			else if (chk == 2)
			{
				chk = 0, chkpwd1 = 0, chkpwd2 =  0, chkpwd3 = 0, time1 = 1000, time2 = 30;
				PORTB &= 0b11111011;
				PORTB |= 0b00010000;
				PORTC |= 0b00100000;
				while (chk == 0) //หลุด loop เมื่อถูก
				{
					time1 -= 1; //นับถอยหลัง
					if (time1 <= 0) {time2 -= 1; time1 = 1000;}

					if (time2 <= 0 && ((PORTC & 0b00100000) == 0)) {PORTC |= 0b00100000; time2 = 30;}
					else if (time2 <= 0 && ((PORTC & 0b00100000) != 0)) {PORTC &= 0b11011111; time2 = 30;}

					if (chkpwd1 == pwd1 && chkpwd2 == pwd2 && chkpwd3 == pwd3) chk = 1; //รหัส 3 ครั้งถูก
					else if (chkpwd3 != 0) //รหัสผิด
					{
						PORTC &= 0b11110111; //ไฟปุ่มดับ
						PORTB |= 0b00000001; //ไฟเขียวติด
						_delay_ms(2000);
						PORTB &= 0b11111110; //ไฟเขียวดับ
						PORTC |= 0b00001000; //ไฟปุ่มติด
						chkpwd1 = 0; chkpwd2 = 0; chkpwd3 = 0;
					};

					if (((PINC & 0b00010000) == 0) && (door == 0)) //กดเปิดประตู
					{
						PORTC &= 0b11110111; //ไฟปุ่มดับ
						while ((PINC & 0b00010000) == 0) //รอจนกว่าปล่อยปุ่ม
							PORTC |= 0b00100000;
						_delay_ms(2000);
						PORTC |= 0b00001010; //ไฟปุ่ม,ประตู ติด
						door = 1;
					}

					if (((PINC & 0b00010000) == 0) && (door == 1)) //กดปิดประตู
					{
						PORTC &= 0b11110111; //ไฟปุ่มดับ
						while ((PINC & 0b00010000) == 0) //รอจนกว่าปล่อยปุ่ม
							PORTC |= 0b00100000;
						_delay_ms(2000);
						PORTC |= 0b00001000; //ไฟปุ่มติด
						PORTC &= 0b11111101; //ไฟประตูดับ
						door = 0;	
					}

					if (((PINB & 0b00000010) == 0)) //กดปุ่มแรก
					{
						PORTC &= 0b11110111; //ไฟปุ่มดับ
						while ((PINB & 0b00000010) == 0) //รอปล่อย
							PORTC |= 0b00100000;
						_delay_ms(2000);
						PORTC |= 0b00001000; //ไฟปุ่มติด
						if (chkpwd1 == 0) chkpwd1 = 1; //ถ้ายังไม่กดครั้งแรก ให้ใส่ค่าแรกก่อน
						else if (chkpwd2 == 0) chkpwd2 = 1; //ครั้ง2
						else if (chkpwd3 == 0) chkpwd3 = 1; //ครั้ง3
					} 

					if (((PINB & 0b00001000) == 0))
					{
						PORTC &= 0b11110111; //ไฟปุ่มดับ
						while ((PINB & 0b00001000) == 0)
							PORTC |= 0b00100000;
						_delay_ms(2000);
						PORTC |= 0b00001000; //ไฟปุ่มติด
						if (chkpwd1 == 0) chkpwd1 = 2;
						else if (chkpwd2 == 0) chkpwd2 = 2;
						else if (chkpwd3 == 0) chkpwd3 = 2;
					}

					if (((PINB & 0b00100000) == 0))
					{
						PORTC &= 0b11110111; //ไฟปุ่มดับ
						while ((PINB & 0b00100000) == 0)
							PORTC |= 0b00100000;
						_delay_ms(2000);
						PORTC |= 0b00001000; //ไฟปุ่มติด
						if (chkpwd1 == 0) chkpwd1 = 3;
						else if (chkpwd2 == 0) chkpwd2 = 3;
						else if (chkpwd3 == 0) chkpwd3 = 3;
					}

					if (((PINC & 0b00000001) == 0)) //กด reset
					{
						PORTC &= 0b11110111; //ไฟปุ่มดับ
						PORTB |= 0b00000001; //ไฟเขียวติด
						while ((PINC & 0b00000001) == 0)
							PORTC |= 0b00100000;
						_delay_ms(2000);
						PORTB &= 0b11111110; //ไฟเขียวดับ
						PORTC |= 0b00001000; //ไฟปุ่มติด
						chkpwd1 = 0; chkpwd2 = 0; chkpwd3 = 0;
					}
				}
//====================================================================================================================================================//
				PORTB |= 0b00000001; //ไฟเขียวติด
				PORTB &= 0b11101111; //ไฟแดงดับ
				PORTC &= 0b11011111; // ดับ buzzer
			}
//====================================================================================================================================================//
			chk = 0; chkpwd1 = 0; chkpwd2 =  0; chkpwd3 = 0; time1 = 1000; time2 = 2500; time3 = 1000; time4 = 1000;
		}
//====================================================================================================================================================//

		if (((PINC & 0b00010000) == 0) && (door == 1)) //กดปิดประตู
		{
			PORTC &= 0b11110111; //ไฟปุ่มดับ
			while ((PINC & 0b00010000) == 0) //รอจนกว่าปล่อยปุ่ม
			;
			_delay_ms(2000);
			PORTC |= 0b00001000; //ไฟปุ่มติด
			PORTC &= 0b11111101; //ไฟประตูดับ
			door = 0;	
		}
//====================================================================================================================================================//
		if (((PINC & 0b00000100) == 0)) //กดเปลี่ยน password
		{
			PORTB &= 0b11111110; //ไฟเขียวดับ
			PORTC &= 0b11110111; //ไฟปุ่มดับ
			while ((PINC & 0b00000100) == 0) //รอจนกว่าปล่อยปุ่ม
			;
			_delay_ms(2000);
			PORTC |= 0b00001000; //ไฟปุ่มติด

			while (chk == 0) //หลุด loop เมื่อกดรหัสใหม่ครบ
			{
				if (chkpwd1 == repwd1 && chkpwd2 == repwd2 && chkpwd3 == repwd3 &&
				    repwd1 != 0 && repwd2 != 0 && repwd3 != 0) chk = 1; //รหัสซ้ำ 3 ครั้งถูก
				else if (repwd3 != 0) { chkpwd1 = 0; chkpwd2 = 0; chkpwd3 = 0; repwd1 = 0; repwd2 = 0; repwd3 = 0; }

				if (((PINC & 0b00010000) == 0) && (door == 0)) //กดเปิดประตู
				{
					PORTC &= 0b11110111; //ไฟปุ่มดับ
					while ((PINC & 0b00010000) == 0) //รอจนกว่าปล่อยปุ่ม
					{
						time3 -= 1;
						if (time3 <= 0) { time4 -= 1; time3 = 1000; }
						if (time4 <= 0) PORTC |= 0b00100000;
					}
					PORTC &= 0b11011111; // ดับ buzzer
					time3 = 1000; time4 = 1000;
					_delay_ms(2000);
					PORTC |= 0b00001010; //ไฟปุ่ม,ประตู ติด
					door = 1;
				}

				if (((PINC & 0b00010000) == 0) && (door == 1)) //กดปิดประตู
				{
					PORTC &= 0b11110111; //ไฟปุ่มดับ
					while ((PINC & 0b00010000) == 0) //รอจนกว่าปล่อยปุ่ม
					{
						time3 -= 1;
						if (time3 <= 0) { time4 -= 1; time3 = 1000; }
						if (time4 <= 0) PORTC |= 0b00100000;
					}
					PORTC &= 0b11011111; // ดับ buzzer
					time3 = 1000; time4 = 1000;
					_delay_ms(2000);
					PORTC |= 0b00001000; //ไฟปุ่มติด
					PORTC &= 0b11111101; //ไฟประตูดับ
					door = 0;	
				}

				if (((PINB & 0b00000010) == 0)) //กดปุ่มแรก
				{
					PORTC &= 0b11110111; //ไฟปุ่มดับ
					while ((PINB & 0b00000010) == 0) //รอปล่อย
					{
						time3 -= 1;
						if (time3 <= 0) { time4 -= 1; time3 = 1000; }
						if (time4 <= 0) PORTC |= 0b00100000;
					}
					PORTC &= 0b11011111; // ดับ buzzer
					time3 = 1000; time4 = 1000;
					_delay_ms(2000);
					PORTC |= 0b00001000; //ไฟปุ่มติด
					if (chkpwd1 == 0) { chkpwd1 = 1; PORTB |= 0b00000001; } //ถ้ายังไม่กดครั้งแรก ให้ใส่ค่าแรกก่อน
					else if (chkpwd2 == 0) { chkpwd2 = 1; PORTB |= 0b00000100; } //ครั้ง2
					else if (chkpwd3 == 0) { chkpwd3 = 1; PORTB |= 0b00010000; _delay_ms(2000); PORTB &= 0b11101010; } //ครั้ง3
					else if (chkpwd3 != 0 && repwd1 == 0) { repwd1 = 1; PORTB |= 0b00000001; }
					else if (repwd2 == 0) { repwd2 = 1; PORTB |= 0b00000100; }
					else if (repwd3 == 0) { repwd3 = 1; PORTB |= 0b00010000; _delay_ms(2000); PORTB &= 0b11101010; }
				} 

				if (((PINB & 0b00001000) == 0))
				{
					PORTC &= 0b11110111; //ไฟปุ่มดับ
					while ((PINB & 0b00001000) == 0)
					{
						time3 -= 1;
						if (time3 <= 0) { time4 -= 1; time3 = 1000; }
						if (time4 <= 0) PORTC |= 0b00100000;
					}
					PORTC &= 0b11011111; // ดับ buzzer
					time3 = 1000; time4 = 1000;
					_delay_ms(2000);
					PORTC |= 0b00001000; //ไฟปุ่มติด
					if (chkpwd1 == 0) { chkpwd1 = 2; PORTB |= 0b00000001; }
					else if (chkpwd2 == 0) { chkpwd2 = 2; PORTB |= 0b00000100; }
					else if (chkpwd3 == 0) { chkpwd3 = 2; PORTB |= 0b00010000; _delay_ms(2000); PORTB &= 0b11101010; }
					else if (chkpwd3 != 0 && repwd1 == 0) { repwd1 = 2; PORTB |= 0b00000001; }
					else if (repwd2 == 0) { repwd2 = 2; PORTB |= 0b00000100; }
					else if (repwd3 == 0) { repwd3 = 2; PORTB |= 0b00010000; _delay_ms(2000); PORTB &= 0b11101010; }
				}

				if (((PINB & 0b00100000) == 0))
				{
					PORTC &= 0b11110111; //ไฟปุ่มดับ
					while ((PINB & 0b00100000) == 0)
					{
						time3 -= 1;
						if (time3 <= 0) { time4 -= 1; time3 = 1000; }
						if (time4 <= 0) PORTC |= 0b00100000;
					}
					PORTC &= 0b11011111; // ดับ buzzer
					time3 = 1000; time4 = 1000;
					_delay_ms(2000);
					PORTC |= 0b00001000; //ไฟปุ่มติด
					if (chkpwd1 == 0) { chkpwd1 = 3; PORTB |= 0b00000001; }
					else if (chkpwd2 == 0) { chkpwd2 = 3; PORTB |= 0b00000100; }
					else if (chkpwd3 == 0) { chkpwd3 = 3; PORTB |= 0b00010000; _delay_ms(2000); PORTB &= 0b11101010; }
					else if (chkpwd3 != 0 && repwd1 == 0) { repwd1 = 3; PORTB |= 0b00000001; }
					else if (repwd2 == 0) { repwd2 = 3; PORTB |= 0b00000100; }
					else if (repwd3 == 0) { repwd3 = 3; PORTB |= 0b00010000; _delay_ms(2000); PORTB &= 0b11101010; }
				}

				if (((PINC & 0b00000001) == 0)) //กด reset
				{
					PORTC &= 0b11110111; //ไฟปุ่มดับ
					PORTB &= 0b11101010; //ไฟเขียว แดง เหลือง ดับ
					while ((PINC & 0b00000001) == 0)
					{
						time3 -= 1;
						if (time3 <= 0) { time4 -= 1; time3 = 1000; }
						if (time4 <= 0) PORTC |= 0b00100000;
					}
					PORTC &= 0b11011111; // ดับ buzzer
					time3 = 1000; time4 = 1000;
					_delay_ms(2000);
					PORTC |= 0b00001000; //ไฟปุ่มติด
					chkpwd1 = 0; chkpwd2 = 0; chkpwd3 = 0; repwd1 = 0; repwd2 = 0; repwd3 = 0;
				}
			}
//====================================================================================================================================================//
			pwd1 = chkpwd1; pwd2 = chkpwd2; pwd3 = chkpwd3; //set pwd ใหม่
			chkpwd1 = 0; chkpwd2 =  0; chkpwd3 = 0; repwd1 = 0; repwd2 = 0; repwd3 = 0; chk = 0; time3 = 1000; time4 = 1000;//reset ค่า
			PORTB |= 0b00000001; //ไฟเขียวติด
		}
//====================================================================================================================================================//
    }
}

